#!/usr/bin/python

import sys
import os
import string

def getData(filename, setVal):
    ret = []
    for line in open(filename):
        cur = line.split(",")
        cur = map(string.strip, cur)
        if ret:
            cur[1:] = map(float, cur[1:])
        ret.append(cur)

    for i in range(1, len(ret)):
        ret[i][i] = setVal
            
    return ret

def printData(data):
    for row in data:
        print row
    print
    

def printTree(tree):
    if not tree: return
    
    (name, left, right, value) = tree
    value = 1.0 / (value + 0.01)
    printTree(left)
    printTree(right)
    if not (left or right):
        return

    print "%s\t%s\t%s\t%s" % (left[0], right[0], value * 5, name)

def avg(l, s=None):
    if s == None:
        return 1.0 * sum(l) / len(l)
    else:
        return round(1.0 * (l + s) / 2, 4)

if 0:
    compFunc = min
    mergeFunc = max
    setVal = 10000
else:
    compFunc = max
    mergeFunc = min
    setVal = 0.0
    
data = getData(sys.argv[1], setVal)
iteration = 1

treeLookup = {}
for i in range(1, len(data)):
    treeLookup[data[0][i]] = [data[0][i], [], [], 0.0]
    
while len(data) > 2:
    # Track how long we have to go
    iteration += 1
    
    # Find the maximum similarity
    x = 1
    m = compFunc(data[1][1:])
    for i in range(2, len(data)):
        temp = compFunc(data[i][1:])
        if compFunc([temp, m]) == temp:
            x = i
            m = temp


    y = data[x].index(m)        
    if x == y:
        #print data[x], x, y
        iteration -= 1
        continue

    # Connect x and y by merging their rows and columns (take min)
    for i in range(len(data)):
        del data[i][max(x, y)]
        del data[i][min(x, y)]

    xData = data[x]
    yData = data[y]

    del data[max(x, y)]
    del data[min(x, y)]

    #print xData[0], yData[0]
    
    linkVal = "N" + str(iteration)
        
    newCol = [linkVal] + \
             [mergeFunc(xData[i], yData[i]) for i in range(1, len(xData))] + \
             [setVal]

    for i in range(len(data)):
        data[i].append(newCol[i])

    treeLookup[newCol[0]] = [newCol[0],
                             treeLookup[xData[0]],
                             treeLookup[yData[0]],
                             m]

    data.append(newCol)

    

    # Repeat
    
printTree(treeLookup[data[0][1]])
